package com.ints.bieshop.domain;

import static org.assertj.core.api.Assertions.assertThat;

public class OrderDetailAsserts {

    /**
     * Asserts that the entity has all properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertOrderDetailAllPropertiesEquals(OrderDetail expected, OrderDetail actual) {
        assertOrderDetailAutoGeneratedPropertiesEquals(expected, actual);
        assertOrderDetailAllUpdatablePropertiesEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all updatable properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertOrderDetailAllUpdatablePropertiesEquals(OrderDetail expected, OrderDetail actual) {
        assertOrderDetailUpdatableFieldsEquals(expected, actual);
        assertOrderDetailUpdatableRelationshipsEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all the auto generated properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertOrderDetailAutoGeneratedPropertiesEquals(OrderDetail expected, OrderDetail actual) {
        assertThat(expected)
            .as("Verify OrderDetail auto generated properties")
            .satisfies(e -> assertThat(e.getId()).as("check id").isEqualTo(actual.getId()));
    }

    /**
     * Asserts that the entity has all the updatable fields set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertOrderDetailUpdatableFieldsEquals(OrderDetail expected, OrderDetail actual) {
        assertThat(expected)
            .as("Verify OrderDetail relevant properties")
            .satisfies(e -> assertThat(e.getPrice()).as("check price").isEqualTo(actual.getPrice()))
            .satisfies(e -> assertThat(e.getQuantity()).as("check quantity").isEqualTo(actual.getQuantity()))
            .satisfies(e -> assertThat(e.getIsDeleted()).as("check isDeleted").isEqualTo(actual.getIsDeleted()));
    }

    /**
     * Asserts that the entity has all the updatable relationships set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertOrderDetailUpdatableRelationshipsEquals(OrderDetail expected, OrderDetail actual) {
        assertThat(expected)
            .as("Verify OrderDetail relationships")
            .satisfies(e -> assertThat(e.getOrder()).as("check order").isEqualTo(actual.getOrder()))
            .satisfies(e -> assertThat(e.getProduct()).as("check product").isEqualTo(actual.getProduct()))
            .satisfies(e -> assertThat(e.getProductOption()).as("check productOption").isEqualTo(actual.getProductOption()));
    }
}
